#include "BLEDevice.h"
#include "BLEScan.h"
#include <WiFi.h>
#include <WiFiUdp.h>
#include <stdio.h>
#include <math.h>
#include <Ticker.h>
Ticker ticker;
#define SERIAL_BAUD 115200
HardwareSerial cardSerial(2);
const char *ssid = "LuBaker";
const char *password = "bakerbaker";
//const char *ssid = "elecrow888";
//const char *password = "elecrow2014";
WiFiUDP udp;
IPAddress remoteIP(172, 20, 10, 8); // Receiver's IP address, cell phone hotspot
//IPAddress remoteIP(192, 168, 60, 119); // Recipient's IP address
//IPAddress remoteIP(192, 168, 3, 119); // Recipient's IP address
//unsigned int localPort = 4210; // local port
unsigned int remotePort = 4211; // Receiver's port

BLEScan* pBLEScan = NULL;
// The remote service we wish to connect to.
static BLEUUID serviceUUID("6479571c-2e6d-4b34-abe9-c35116712345");  //Host service UUID
static BLEUUID charUUID("826f072d-f87c-4ae6-a416-6ffdcaa02d73");
static BLEUUID SEND_UUID("a655223b-5f59-4794-ba1f-3e8a4f51da69");
static BLEUUID Warning_UUID("71d5a0ad-0f4c-49c4-856c-612d837c5f86");
static boolean doConnect = false;                        //Connection sign
static boolean connected = false;                        //Connection success flag
static boolean doSacn = true;                            //Scan flag
static BLERemoteCharacteristic* pRemoteCharacteristic;   //Characteristic value sent by handle
static BLERemoteCharacteristic* pRemoteCharacteristic2;  //Ultrasonic characteristic value
static BLERemoteCharacteristic* pRemoteCharacteristic3;  //Warning characteristic value
static BLEAdvertisedDevice* pServer;
const int leftgo_Pin = 12;
const int lefttrun_Pin = 13;
const int rightgo_Pin = 14;
const int righttrun_Pin = 15;
const int Photodiode_R = 34, Photodiode_L = 35;  //Light seeking pin
int Ultrasonic_Pin = 27, Button_pin = 18;        //Ultrasonic and switch key pins
int QTI_Max, QTI_L = 39, QTI_R = 36;             //Line patrol pin
static int state_L, state_N;                     //Infrared remote control data recording
char LU[10];                                     //Save ultrasonic distance data
std::string value;
BLEClient* pClient = NULL;
BLERemoteService* pRemoteService = NULL;

float num0 ;
float num1 ;
float num2 ;

// Defining Vector Structures
typedef struct {
  float x;
  float y;
} Vector;

// Calculate the distance between two points
float distance(Vector p1, Vector p2) {
  float dx = p1.x - p2.x;
  float dy = p1.y - p2.y;
  return sqrtf(dx * dx + dy * dy);
}

// Calculate the positional coordinates of the label
void trilateration(Vector base1, Vector base2, Vector base3,
                   float d1, float d2, float d3,
                   Vector *tag_pos) {
  float x, y;
  float A, B, C, D, E, F;
  A = 2 * base2.x - 2 * base1.x;
  B = 2 * base2.y - 2 * base1.y;
  C = d1 * d1 - d2 * d2 - base1.x * base1.x + base2.x * base2.x - base1.y * base1.y + base2.y * base2.y;
  D = 2 * base3.x - 2 * base2.x;
  E = 2 * base3.y - 2 * base2.y;
  F = d2 * d2 - d3 * d3 - base2.x * base2.x + base3.x * base3.x - base2.y * base2.y + base3.y * base3.y;
  x = (C * E - F * B) / (E * A - B * D);
  y = (C * D - A * F) / (B * D - A * E);
  tag_pos->x = x;
  tag_pos->y = y;
}

// Assuming the location of the base station is known and the coordinates are in meters
Vector base1 = {0, 0};
Vector base2 = {4, 0};
Vector base3 = {0, 4};
Vector tag_pos1;

static void NotifyCallback(BLERemoteCharacteristic* pBLERemoteCharacteristic, uint8_t* pData, size_t length, bool isNotify) {
  //  char buf[length + 1];
  //  for (size_t i = 0; i < length; i++) {
  //    buf[i] = pData[i];
  //  }
  //  buf[length] = 0;
  //Serial.printf("The contents received are:: %s\r\n", buf);
}


// Callback function for connection and disconnection between client and server
class MyClientCallback : public BLEClientCallbacks {
    void onConnect(BLEClient* pclient) {}
    void onDisconnect(BLEClient* pclient) {
      doSacn = true;
      connected = false;
      Serial.println("Lost connection to device");
      pBLEScan->setActiveScan(true);  //Turn on scanning
      pBLEScan->setInterval(100);
      pBLEScan->setWindow(99);
    }
};

bool ConnectToServer(void) {
  // Create client
  pClient = BLEDevice::createClient();
  //Serial.println("Create client");
  Serial.println("Create Client");

  // Add callback function for connection and disconnection between client and server
  pClient->setClientCallbacks(new MyClientCallback());  // Add callback function for connection and disconnection between client and server

  // Try to connect the device
  if (!pClient->connect(pServer)) {  // Try to connect the device
    Serial.println("Failed to connect to the device");
    return false;
  }
  //Serial.println("Connect device successfully");
  Serial.println("Connect Bluetooth ESP32 successfully");
  // Try to get the service in the device
  pRemoteService = pClient->getService(serviceUUID);
  if (pRemoteService == nullptr) {
    pClient->disconnect();
    return false;
  }
  //Serial.println("Obtain service successfully");
  Serial.println("Successful acquisition of services");
  //Send feature value binding
  pRemoteCharacteristic2 = pRemoteService->getCharacteristic(SEND_UUID);
  pRemoteCharacteristic3 = pRemoteService->getCharacteristic(Warning_UUID);

  // Try to get the characteristics in the service
  pRemoteCharacteristic = pRemoteService->getCharacteristic(charUUID);
  if (pRemoteCharacteristic == nullptr) {
    Serial.println("Failed to get attribute");
    pClient->disconnect();
    return false;
  }
  //Serial.println("Get features successfully");
  Serial.println("Successful acquisition of services");
  // If the characteristic value can be read, read the data
  if (pRemoteCharacteristic->canRead()) {
    value = pRemoteCharacteristic->readValue();
    //    Serial.print("The characteristic value can be read and the current value is: ");
    //    Serial.println(value.c_str());
  }

  // If push is enabled for feature values, push receiving processing is added
  if (pRemoteCharacteristic->canNotify()) {
    pRemoteCharacteristic->registerForNotify(NotifyCallback);
  }
  connected = true;
  return true;
}


class MyAdvertisedDeviceCallbacks : public BLEAdvertisedDeviceCallbacks {
    void onResult(BLEAdvertisedDevice advertisedDevice) {
      //Serial.print("BLE Advertised Device found: ");
      //Serial.println(advertisedDevice.toString().c_str());

      // Callback function when a device is found
      if (advertisedDevice.haveServiceUUID() && advertisedDevice.getServiceUUID().equals(serviceUUID)) {
        //Serial.print("Find device！  address: ");
        advertisedDevice.getScan()->stop();                   // Stop current scan
        pServer = new BLEAdvertisedDevice(advertisedDevice);  // Temporary storage device
        doConnect = true;
        doSacn = false;
        //Serial.println("Find the device you want to connect");
        Serial.println("Locate the device to be connected: ESP32");
      }
    }
};

void callback1()  //Callback function
{

}
//Wheel movement
void Motor(int L1, int L2, int R1, int R2) {
  ledcWrite(13, L1);
  ledcWrite(12, L2);
  ledcWrite(15, R1);
  ledcWrite(14, R2);
}
void setup() {
  Serial.begin(115200);
  cardSerial.begin(SERIAL_BAUD, SERIAL_8N1, 21, 22);
  //wheel
  pinMode(12, OUTPUT);  //Left wheel forward
  pinMode(13, OUTPUT);  //Left wheel backward
  pinMode(14, OUTPUT);  //Right wheel forward
  pinMode(15, OUTPUT);  //Right wheel backward
  //Bind wheels
  for (int i = 12; i <= 15; i++) {  //Motor port is 12,13,14,15
    ledcSetup(i, 255, 8);           //leds Setting (channel, frequency, number of bits)
    ledcAttachPin(i, i);            //Motor port binding corresponding channel
  }
  //BT Switch
  pinMode(32, INPUT);  //BT Switch
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(50);
    Serial.print(".");
  }

  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  delay(500);

  cardSerial.println("AT");
  delay(500);
  cardSerial.println("AT+RST");
  delay(500);
  cardSerial.println("AT+anchor_tag=0");
  delay(500);
  cardSerial.println("AT+interval=5");
  delay(500);
  cardSerial.println("AT+switchdis=1");
  delay(1000);

  //BLE
  //Serial.println("Starting Arduino BLE Client application...");
  BLEDevice::init("");
  BLEDevice::setPower(ESP_PWR_LVL_P9);  //Set transmission frequency
  pBLEScan = BLEDevice::getScan();
  pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
  pBLEScan->setActiveScan(true);  //Turn on scanning
  pBLEScan->setInterval(100);
  pBLEScan->setWindow(99);
  //  ticker.attach_ms(1, callback1);  //lighting task
}

void loop() {
  // Scan if needed
  if (doSacn == true) {
    Serial.println("Start searching Bluetooth devices...");
    //Serial.println("Start searching for devices");
    BLEDevice::getScan()->clearResults();
    BLEDevice::getScan()->start(1);  // Continuously search for devices
  }

  //If the connection is successful
  if (doConnect == true) {
    if (ConnectToServer() == true) {
      //Serial.println("We are now connecting to the server...");
      Serial.println("connecting to the server...");
      //        Serial.println("3");
      //        delay(500);
      //        Serial.println("2");
      //        delay(500);
      //        Serial.println("1");
      //        delay(500);
      Serial.println("connect successfully...");

      connected = true;
    } else {
      doSacn = true;
    }
    doConnect = false;
  }



  //If the device is connected
  if (connected == true) {
    value = pRemoteCharacteristic->readValue();
    if (value == "Y")  //forward
    {
      //delay(5);
      Motor(200, 0, 200, 0);
    }

    if (value == "X")  //towards the right
    {
      Motor(60, 0, 0, 60);
    }

    if (value == "y")  //backward
    {
      //delay(5);
      Motor(0, 160, 0, 160);
    }

    if (value == "x")  //towards the left
    {
      Motor(0, 60, 60, 0);
    }

    if (value == "XY")  //Right up
    {
      //delay(5);
      Motor(170, 0, 80, 0);
    }

    if (value == "Xy")  //Lower right
    {
      //delay(5);
      Motor(0, 170, 0, 80);
    }

    if (value == "xY")  //Upper left
    {
      //delay(5);
      Motor(80, 0, 170, 0);
    }

    if (value == "xy")  //Lower left
    {
      //delay(5);
      Motor(0, 80, 0, 170);
    }

    if (value == "N")  //stop it
    {
      Motor(0, 0, 0, 0);
    }

    while (cardSerial.available()) { // Check for available data in the serial port buffer
      String input = cardSerial.readStringUntil('\n'); // Read a line of data
      if (input.indexOf("distance0") >= 0) { // Determine if the read data contains the string "distance".
        //      Serial.println(input); // If contained, print it out
        int colonIndex0 = input.indexOf(':');  // Find the position of the colon
        int mIndex0 = input.indexOf('m', colonIndex0 + 1); // Find the position of m starting from the colon position
        String numStr0 = input.substring(colonIndex0 + 1, mIndex0); // Substring between colon position +1 and m position
        num0 = numStr0.toFloat();  // Converting strings to floats
        Serial.print("anchor0:");
        Serial.println(num0);  // Print the extracted float number
      }
      if (input.indexOf("distance1") >= 0) { // Determine if the read data contains the string "distance".
        int colonIndex1 = input.indexOf(':');  // Read a line of data
        int mIndex1 = input.indexOf('m', colonIndex1 + 1); // Find the position of m starting from the colon position
        String numStr1 = input.substring(colonIndex1 + 1, mIndex1); // Substring between colon position +1 and m position
        num1 = numStr1.toFloat();  // Converting strings to floats
        Serial.print("anchor1:");
        Serial.println(num1);  // Print the extracted float number
      }
      if (input.indexOf("distance2") >= 0) { // Determine if the read data contains the string "distance".
        int colonIndex2 = input.indexOf(':');  // Read a line of data
        int mIndex2 = input.indexOf('m', colonIndex2 + 1); // Find the position of m starting from the colon position
        String numStr2 = input.substring(colonIndex2 + 1, mIndex2); // Substring between colon position +1 and m position
        num2 = numStr2.toFloat();  // Converting strings to floats
        Serial.print("anchor2:");
        Serial.println(num2);  // Print the extracted float number
      }
      trilateration(base1, base2, base3, num0, num1, num2, &tag_pos1);

      // Print the position coordinates of the label
      char buffer1[100];
      //      Serial.printf("Tag position: (%.2f , %.2f m)\n", tag_pos1.x, tag_pos1.y);
      sprintf(buffer1, "Tag position:%.2f,%.2f\n", tag_pos1.x, tag_pos1.y);
      char* p = strtok(buffer1, ":,"); // Split string into substrings
      p = strtok(NULL, ":,"); // Get the substring after the colon
      float x = atof(p); // Parses the first float as x
      p = strtok(NULL, ":,"); // Get sub-string after comma
      float y = atof(p); // Parses the second float as y
      String message1 = String(x) + "," + String(y);
      udp.beginPacket(remoteIP, remotePort);
      udp.print(message1);
      udp.endPacket();
      memset(buffer1, 0, sizeof(buffer1));
    }
  }
  while (cardSerial.available()) { // Check for available data in the serial port buffer
    String input = cardSerial.readStringUntil('\n'); // Reading a line of data
    if (input.indexOf("distance0") >= 0) { // Determine if the read data contains the string "distance".
      //      Serial.println(input); // If included, print it out
      int colonIndex0 = input.indexOf(':');  // Find the position of the colon
      int mIndex0 = input.indexOf('m', colonIndex0 + 1); // Find the position of m starting from the colon position
      String numStr0 = input.substring(colonIndex0 + 1, mIndex0); // Substring between colon position +1 and m position
      num0 = numStr0.toFloat();  // Converting strings to floats
      Serial.print("anchor0:");
      Serial.println(num0);  // Print the extracted float number
    }
    if (input.indexOf("distance1") >= 0) { // Check for available data in the serial port buffer
      int colonIndex1 = input.indexOf(':');  // Find the position of the colon
      int mIndex1 = input.indexOf('m', colonIndex1 + 1); // Find the position of m starting from the colon position
      String numStr1 = input.substring(colonIndex1 + 1, mIndex1); // Substring between colon position +1 and m position
      num1 = numStr1.toFloat();  // Converting strings to floating point numbers
      Serial.print("anchor1:");
      Serial.println(num1);  // Print the extracted floating point number
    }
    if (input.indexOf("distance2") >= 0) { // Determine if the read data contains the string "distance".
      int colonIndex2 = input.indexOf(':');  // Find the position of the colon
      int mIndex2 = input.indexOf('m', colonIndex2 + 1); // Find the position of m starting from the colon position
      String numStr2 = input.substring(colonIndex2 + 1, mIndex2); // Substring between colon position +1 and m position
      num2 = numStr2.toFloat();  // Converting strings to floating point numbers
      Serial.print("anchor2:");
      Serial.println(num2);  // Print the extracted floating point number
    }
    trilateration(base1, base2, base3, num0, num1, num2, &tag_pos1);

    // Print the position coordinates of the label
    char buffer1[100];
    //      Serial.printf("Tag position: (%.2f , %.2f m)\n", tag_pos1.x, tag_pos1.y);
    sprintf(buffer1, "Tag position:%.2f,%.2f\n", tag_pos1.x, tag_pos1.y);
    char* p = strtok(buffer1, ":,"); // Splitting a string into substrings
    p = strtok(NULL, ":,"); // Get the substring after the colon
    float x = atof(p); // Parses the first float as x
    p = strtok(NULL, ":,"); // Get the substring after the comma
    float y = atof(p); // Parses the second float as y
    String message1 = String(x) + "," + String(y);
    udp.beginPacket(remoteIP, remotePort);
    udp.print(message1);
    udp.endPacket();
    memset(buffer1, 0, sizeof(buffer1));
  }

}
